/* 
 * Copyright (c) 2012 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice and this list of conditions.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice and  this list of  conditions in the  documentation and/or
 *      other materials provided with the distribution.
 *
 *					Anthony Mallet on Fri Mar 23 2012
 */

#ifndef H_GENOMIX
#define H_GENOMIX

#include <tcl.h>

#include "genom3/c/client.h"


/* client handle */
struct gnmx_handle {
  Tcl_Interp *interp;
  Tcl_Command token;
  char *path;
  void *dlh;
  struct genom_client_info *info;
  genom_client c;
  int eventfd;

  struct gnmx_handle *next;
};

extern struct gnmx_handle *gnmx_clients;

int	gnmx_rpath(ClientData data, Tcl_Interp *interp, int objc,
		Tcl_Obj *const objv[]);
int	gnmx_load(ClientData data, Tcl_Interp *interp, int objc,
		Tcl_Obj *const objv[]);

void	gnmx_watch_init(void);
void	gnmx_watch(struct gnmx_handle *h);
void	gnmx_unwatch(struct gnmx_handle *h);


void	gnmx_atexit_push(void *dlhandle);
void	gnmx_atexit_pop(void);
void	gnmx_atexit_invoke(void *dhlandle);

#endif /* H_GENOMIX */
